#include <stdio.h>
#include <errno.h>
#include "gchdr.h"
#include "gcio.h"

int debug = 0;
static int pe[ANZ_TL] = {0, 50, 150, 300, 700, 1250, 2050, 3150, 4600, 6450};

static BYTE put___vln _(( char *, int *, int ));
static BYTE get___doc _(( char *, int *, int * ));
int main _(( int, char *[] ));


static BYTE put___vln(P(char *) player, P(int *) level, P(int) date)
PP(char *player;)
PP(int *level;)
PP(int date;)
{
	FILE *vln_datei;
	char datei[MAX_PATHLEN];
	int forschung;

	sprintf(datei, "%s%s", player, EXT_VLN);
	if ((vln_datei = fopen(datei, FWRITE_TEXT)) == NULL)
	{
		fclose(vln_datei);
		return FEHLER_C;
	}
	fprintf(vln_datei, "0 %d 0 0\n", date);

	for (forschung = 0; forschung < ANZ_FG; forschung++)
		fprintf(vln_datei, "101 %d %d %d\n", forschung, pe[level[forschung]], level[forschung]);

	fclose(vln_datei);
	return (OK);
}


static BYTE get___doc(P(char *) player, P(int *) level, P(int *) date)
PP(char *player;)
PP(int *level;)
PP(int *date;)
{
	FILE *doc_datei;
	char datei[MAX_PATHLEN];
	STATIC char r_buf[2048];
	int forschung;
	long score;
	int pl, sh, pe;
	int fg[ANZ_FG];

	sprintf(datei, "%s%s", player, ".doc");
	if ((doc_datei = fopen(datei, FREAD_TEXT)) == NULL)
	{
		return FEHLER_C;
	}
	if (NULL == fgets(r_buf, (int) sizeof(r_buf), doc_datei))
	{
		fclose(doc_datei);
		return (FEHLER_F);
	}
	if (NULL == fgets(r_buf, (int) sizeof(r_buf), doc_datei))
	{
		fclose(doc_datei);
		return (FEHLER_F);
	}
	for (forschung = 0; forschung < ANZ_FG; forschung++)
		level[forschung] = 0;
	while (NULL != fgets(r_buf, (int) sizeof(r_buf), doc_datei))
	{
		if (sscanf(r_buf, "%4d %ld %d %d %d  %1d %1d %1d %1d %1d %1d %1d",
				   date, &score, &pl, &sh, &pe,
				&fg[0], &fg[1], &fg[2], &fg[3], &fg[4], &fg[5], &fg[6]) != 12)
		{
			fclose(doc_datei);
			return (FEHLER_F);
		}
		for (forschung = 0; forschung < ANZ_FG; forschung++)
			if (fg[forschung] > level[forschung])
				level[forschung] = fg[forschung];
	}
	fclose(doc_datei);
	return (OK);
}


int main(P(int) argc, P(char **) argv)
PP(int argc;)
PP(char **argv;)
{
	char *zeichen;
	BYTE result;
	int spieler, zeit, forschung;
	int level[ANZ_FG];

	for (spieler = 1; spieler < argc; spieler++)
	{
		fprintf(stderr, "lese %s", argv[spieler]);
		fflush(stderr);
		zeichen = argv[spieler];
		while (*zeichen != 0 && *zeichen != '.')
			zeichen++;
		if (*zeichen == '.')
			*zeichen = 0;
		if ((result = get___doc(argv[spieler], level, &zeit)) != OK)
		{
			fprintf(stderr, " fehler beim lesen von %s\n", argv[spieler]);
		} else {
			for (forschung = 0; forschung < ANZ_FG; forschung++)
				fprintf(stderr, " %1d", level[forschung]);
			fprintf(stderr, " date %4d\n", zeit);
			if ((result = put___vln(argv[spieler], level, zeit)) != OK)
			{
				fprintf(stderr, " fehler beim schreiben von %s\n", argv[spieler]);
				return (result);
			}
		}
	}
	return (0);
}
